/*!jQuery ertan3d-slider*/
/**
 * 360 degree slider
 * www.cekirdek.com.tr, 
 * Version: 1.2 (3/11/2013)
 * Requires: jQuery v1.6+
 *
 * Copyright (c) 2013 Ertan BLER
 * Under MIT and GPL licenses:
 *  http://www.opensource.org/licenses/mit-license.php
 *  http://www.gnu.org/licenses/gpl.html
*/
(function($) {

    /**
     * Kontrol library
     */
    "use strict";
 
  var ertan = {}, self = ertan;
  
  ertan.options = {
    mode : 2,  
    start_index : 0,
    elements : [],  
    stops : [], 
    animate : false,
    left : ".left-turn",  
    right : ".right-turn", 
    load_num : 0, // 0 = all 
    press_time : 100,  
    delay : 500,  
    onnext : function(){}, // cb
    onprev : function(){}, // cb
    onsetted : function(){}, //cb
    oninited : function(){}, // cb
    inited : false
  };
 
  
  ertan.setDeceleratingTimeout = function setDeceleratingTimeout( callback, factor, times )
  {
    var internalCallback = function( t, counter )
    {
      return function()
      {
        if ( --t > 0 )
        {
          window.setTimeout( internalCallback, ++counter * factor );
          callback();
        }
      }
    }( times, 0 );

    window.setTimeout( internalCallback, factor );
  };
  ertan.init = function(t,options){
    
    options = $.extend(self.options, options);
    
    options.current_index=options.start_index,
    options.next_item = (options.elements[(options.start_index +1)] ) ? options.start_index + 1 : 0 , 
    options.prev_item = (options.elements[(options.start_index -1)] ) ? options.start_index - 1 : options.elements.length-1 , 
    options.$target = $(t);
     
    if(!options.elements[options.start_index])
    return false;
    
       
    
    self.set(options.start_index);
    
    var pressed = "", timeout="";
    
    if(options.stops.length && options.animate)
    {
      //options.stops.sort();
      var stops_count = [], c = options.elements.length  ;
      
      var cxfirst = 0, cx = 0, cy= 0;
      $.each(options.stops,function(i,e){
         var ind = i+1,last = false;
         if(ind >= options.stops.length)
         {
          ind =  0;
          last = true;
         }
         var start_pos = e, end_pos = options.stops[ind];
         if(!last)
         {
            cx = end_pos -start_pos ;
         }
         else
         {
            cx = c- start_pos + end_pos    ;
         }
          
         cy  = (cx + 1 ) * cx /2 ;
         stops_count[e] = { "c": cx, "t" : options.delay/cy  } ;
         
         
      });
    }
     
    
    $(options.left).on("click",function(){
       self.prev(true);
       if(options.stops.length)
       {   
          if(!options.animate)
          {
            clearInterval(pressed);
            pressed = setInterval(function(){
              self.prev(true);
              if(jQuery.inArray(options.prev_item,options.stops) != -1)
              {
                clearInterval(pressed);
              }
            },options.delay);
          }
          else
          {
            var witch_stop = options.prev_item, ws =[]; //Math.max.apply( Math, array );
            $.each(options.stops,function(i,e){
              if( (e < options.prev_item && options.prev_item != Math.min.apply( Math, options.stops ) )  || (options.current_index == Math.min.apply( Math, options.stops ) && e > options.prev_item) )
              { 
                  ws.push(e); 
              } 
            }); 
            
            witch_stop =  Math.max.apply( Math, ws ) ;
            self.setDeceleratingTimeout(function(){ self.prev(true);},stops_count[witch_stop].t,stops_count[witch_stop].c);
          }
       }
    });
    
    $(options.right).on("click",function(){
      
      self.next(true);
      if(options.stops.length)
       {   
          if(!options.animate)
          {
            clearInterval(pressed);
            pressed = setInterval(function(){
              self.next(true);
              if(jQuery.inArray(options.next_item,options.stops) != -1)
              {
                clearInterval(pressed);
              }
            },options.delay);
          }
          else
          {
            var witch_stop = options.next_item ;  
            
            witch_stop =  options.current_index ;
            self.setDeceleratingTimeout(function(){ self.next(true);},stops_count[witch_stop].t,stops_count[witch_stop].c);
          }
       }
       
    });
    
    
    
    
    if(options.stops.length == 0) // dndrme
    {
    
      $(options.left).on("mousedown",function(){
        
        clearTimeout(timeout);
        clearInterval(pressed);
        timeout = setTimeout(function(){
          pressed = setInterval(function(){
            self.prev(true);
          },options.press_time);
        },options.delay);
      });
      
      $(options.right).on("mousedown",function(){
      
        clearTimeout(timeout);
        clearInterval(pressed);
        timeout = setTimeout(function(){
          pressed = setInterval(function(){
            self.next(true);
          },options.press_time);
        },options.delay);
        
      });
      var key_act = true;
      $("input, textarea").on("focus",function(){key_act = false;});
      $("input, textarea").on("blur",function(){key_act = true;});
      $(window).on("keydown",function(e){
        if(e.keyCode == 37 && key_act)
        {
          self.prev(true);
          clearTimeout(timeout);
          clearInterval(pressed);
          timeout = setTimeout(function(){
            pressed = setInterval(function(){
              self.prev(true);
            },options.press_time);
          },options.delay);
          
        }
      });
      $(window).on("keydown",function(e){
        if(e.keyCode == 39 && key_act)
        {
          self.next(true);
          clearTimeout(timeout);
          clearInterval(pressed);
          timeout = setTimeout(function(){
            pressed = setInterval(function(){
              self.next(true);
            },options.press_time);
          },options.delay);
        }
      });
      $(window).on("keyup",function(){
        clearTimeout(timeout);
          clearInterval(pressed);
      });
      
      
      $(options.left+","+options.right).on("mouseup",function(){
        clearInterval(pressed);
        clearTimeout(timeout);
      });
    }
    else // klavye iin
    {
      var key_act = true;
      $("input, textarea").on("focus",function(){key_act = false;});
      $("input, textarea").on("blur",function(){key_act = true;});
      $(window).on("keydown",function(e){
        if(e.keyCode == 37 && key_act)
        {
           key_act =false;
          self.prev(true);
          if(!options.animate)
          {
            clearInterval(pressed);
            pressed = setInterval(function(){
              self.prev(true);
              if(jQuery.inArray(options.prev_item,options.stops) != -1)
              {
                 key_act =true;
                clearInterval(pressed);
              }
            },options.delay);
          }
          else
          {
             var witch_stop = options.prev_item, ws =[]; //Math.max.apply( Math, array );
            $.each(options.stops,function(i,e){
              if( (e < options.prev_item && options.prev_item != Math.min.apply( Math, options.stops ) )  || (options.current_index == Math.min.apply( Math, options.stops ) && e > options.prev_item) )
              { 
                  ws.push(e); 
              } 
            }); 
            
            witch_stop =  Math.max.apply( Math, ws ) ;
               
            self.setDeceleratingTimeout(function(){ 
              if(jQuery.inArray(options.prev_item,options.stops) != -1)
              {
                 key_act =true;
                
              }
              self.prev(true);  
            },stops_count[witch_stop].t,stops_count[witch_stop].c);
          }
          
        }
        else if(e.keyCode == 39 && key_act)
        {
          key_act = false;
          self.next(true);
          if(!options.animate)
          {
            clearInterval(pressed);
            pressed = setInterval(function(){
              self.next(true);
              if(jQuery.inArray(options.next_item,options.stops) != -1)
              {
                clearInterval(pressed);
              }
            },options.delay);
          }
          else
          {
            var witch_stop = options.next_item ;  
            
            witch_stop =  options.current_index ;
            
            self.setDeceleratingTimeout(function(){ 
              self.next(true);
              if(jQuery.inArray(options.next_item,options.stops) != -1)
              {
                 key_act =true;
                
              }
            },stops_count[witch_stop].t,stops_count[witch_stop].c);
          }
        }
      });
       
     
    }
    
    var _load  = (!options.load_num) ? options.elements.length-1 : options.load_num;
    for(var i = 0; i <= _load; i++)
    {
      self.load(options.next_item+i);
      self.load(options.prev_item-i);
    } 
    
    if(typeof self.options.oninited == "function")
    {
      self.options.inited = true;
      self.options.oninited(this);
    }
  
  };
  ertan.set = function(index){
    
    self.options.current_index = index,
    self.options.next_item = (self.options.elements[(self.options.current_index +1)] ) ? self.options.current_index + 1 : 0 , 
    self.options.prev_item = (self.options.elements[(self.options.current_index -1)] ) ? self.options.current_index - 1 : self.options.elements.length-1 ;
    
     
     
    if(self.options.mode == 1)
    {
        $(self.options.$target).css("background-image","url('"+self.options.elements[index]+"')");
    }
    else if(self.options.mode == 2)
    {
      //nce gizleyelim
      //$(self.options.$target).fadeTo(0,0);
      
      var area_width = $(self.options.$target).width() ;
        if(!self.options.inited)
        {
          var bgi = [];
          var bgp = [];
          $.each(self.options.elements,function(i,e)
          {
             bgi.push("url('"+e+"')");
             bgp.push( ((index != i) ? -1*area_width : 0)+"px 0px" );
          });
          
          $(self.options.$target).css({ "background-image":bgi.join(","),"background-position":bgp.join(",") });
        }
        else
        {
          var bgp = [];
          $.each(self.options.elements,function(i,e)
          {
             bgp.push( ((index != i) ? -1*area_width : 0)+"px 0px" );
          });
          $(self.options.$target).css( "background-position",bgp.join(",") );
        }
    } 
    
    if(typeof self.options.onsetted == "function")
    {
      self.options.onsetted(this);
    } 
    //console.log(index);
  };
  ertan.next = function(set){
    
    var item = self.options.elements[self.options.next_item];
    var img = new Image;       
    img.onload = function(){   
      if(set)
      self.set(self.options.next_item);
      
    };
    img.src = item;
    if(typeof self.options.onnext == "function")
    {
      return self.options.onnext(this);
    }
   
  };
  ertan.prev = function(set){
    
    var item = this.options.elements[self.options.prev_item];
    var img = new Image;       
    img.onload = function(){   
      if(set)
      self.set(self.options.prev_item);
    };
    img.src = item;
    if(typeof self.options.onprev == "function")
    {
      return self.options.onprev(this);
    }
   
  };
  ertan.load = function(index){
   /* var img = new Image;       
    img.src = self.options.elements[index];*/
    var im = $("<img>").attr("src",self.options.elements[index]).load(function() {
     // console.log("[ertan3d] loadded: "+self.options.elements[index]);
    });
  };
    
    
  $.fn.ertan3d = function (o) {
        return this.each(
           
            function () {
               var t = this;
                var d = ertan.init(t,o);
            }
        );
    };  
    
})(jQuery);